--- gambit-c.txi	Wed Sep  2 14:34:40 2009
+++ gambit-c.alex.txi	Wed Sep  2 15:17:52 2009
@@ -3297,6 +3297,15 @@
 @node Miscellaneous extensions, Undocumented extensions, Extensions to standard special forms, Scheme extensions
 @section Miscellaneous extensions
 
+@deffn procedure append-vectors @var{lst}
+
+This procedure is the vector analog of the @code{append}
+procedure. @var{lst} must be a list of vectors. It returns a newly
+allocated vector whose elements form the concatenation of all the
+vectors in the list.
+
+@end deffn
+
 @deffn procedure vector-copy @var{vector}
 
 This procedure returns a newly allocated vector with the same content
@@ -3322,6 +3331,27 @@
 
 @end deffn
 
+@deffn procedure subvector-fill! @var{vector} @var{start} @var{end} @var{fill}
+
+This procedure is like @code{vector-fill!}, but can fill only part of
+the given vector. It sets the elements of the vector @var{vector},
+beginning with index @var{start} (inclusive) and ending with index
+@var{end} (exclusive) to @var{fill}.
+
+@end deffn
+
+@deffn procedure subvector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
+
+This procedure replaces part of the contents of vector
+@var{dst-vector} with part of the contents of vector
+@var{src-vector}. It copies elements from @var{src-vector}, beginning
+with index @var{src-start} (inclusive) and ending with index
+@var{src-end} (exclusive) to @var{dst-vector} beginning with index
+@var{dst-start} (inclusive). It returns the modified vector
+@var{dst-vector}.
+
+@end deffn
+
 @deffn procedure box @var{obj}
 @deffnx procedure box? @var{obj}
 @deffnx procedure unbox @var{box}
@@ -5104,9 +5134,12 @@
 @deffnx procedure s8vector->list @var{s8vector}
 @deffnx procedure list->s8vector @var{list-of-exact-int8}
 @deffnx procedure s8vector-fill! @var{s8vector} @var{fill}
+@deffnx procedure append-s8vectors @var{lst}
 @deffnx procedure s8vector-copy @var{s8vector}
 @deffnx procedure s8vector-append @var{s8vector}@dots{}
 @deffnx procedure subs8vector @var{s8vector} @var{start} @var{end}
+@deffnx procedure subs8vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subs8vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure u8vector? @var{obj}
@@ -5118,9 +5151,12 @@
 @deffnx procedure u8vector->list @var{u8vector}
 @deffnx procedure list->u8vector @var{list-of-exact-int8}
 @deffnx procedure u8vector-fill! @var{u8vector} @var{fill}
+@deffnx procedure append-u8vectors @var{lst}
 @deffnx procedure u8vector-copy @var{u8vector}
 @deffnx procedure u8vector-append @var{u8vector}@dots{}
 @deffnx procedure subu8vector @var{u8vector} @var{start} @var{end}
+@deffnx procedure subu8vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subu8vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure s16vector? @var{obj}
@@ -5132,9 +5168,12 @@
 @deffnx procedure s16vector->list @var{s16vector}
 @deffnx procedure list->s16vector @var{list-of-exact-int16}
 @deffnx procedure s16vector-fill! @var{s16vector} @var{fill}
+@deffnx procedure append-s16vectors @var{lst}
 @deffnx procedure s16vector-copy @var{s16vector}
 @deffnx procedure s16vector-append @var{s16vector}@dots{}
 @deffnx procedure subs16vector @var{s16vector} @var{start} @var{end}
+@deffnx procedure subs16vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subs16vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure u16vector? @var{obj}
@@ -5146,9 +5185,12 @@
 @deffnx procedure u16vector->list @var{u16vector}
 @deffnx procedure list->u16vector @var{list-of-exact-int16}
 @deffnx procedure u16vector-fill! @var{u16vector} @var{fill}
+@deffnx procedure append-u16vectors @var{lst}
 @deffnx procedure u16vector-copy @var{u16vector}
 @deffnx procedure u16vector-append @var{u16vector}@dots{}
 @deffnx procedure subu16vector @var{u16vector} @var{start} @var{end}
+@deffnx procedure subu16vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subu16vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure s32vector? @var{obj}
@@ -5160,9 +5202,12 @@
 @deffnx procedure s32vector->list @var{s32vector}
 @deffnx procedure list->s32vector @var{list-of-exact-int32}
 @deffnx procedure s32vector-fill! @var{s32vector} @var{fill}
+@deffnx procedure append-s32vectors @var{lst}
 @deffnx procedure s32vector-copy @var{s32vector}
 @deffnx procedure s32vector-append @var{s32vector}@dots{}
 @deffnx procedure subs32vector @var{s32vector} @var{start} @var{end}
+@deffnx procedure subs32vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subs32vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure u32vector? @var{obj}
@@ -5174,9 +5219,12 @@
 @deffnx procedure u32vector->list @var{u32vector}
 @deffnx procedure list->u32vector @var{list-of-exact-int32}
 @deffnx procedure u32vector-fill! @var{u32vector} @var{fill}
+@deffnx procedure append-u32vectors @var{lst}
 @deffnx procedure u32vector-copy @var{u32vector}
 @deffnx procedure u32vector-append @var{u32vector}@dots{}
 @deffnx procedure subu32vector @var{u32vector} @var{start} @var{end}
+@deffnx procedure subu32vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subu32vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure s64vector? @var{obj}
@@ -5188,9 +5236,12 @@
 @deffnx procedure s64vector->list @var{s64vector}
 @deffnx procedure list->s64vector @var{list-of-exact-int64}
 @deffnx procedure s64vector-fill! @var{s64vector} @var{fill}
+@deffnx procedure append-s64vectors @var{lst}
 @deffnx procedure s64vector-copy @var{s64vector}
 @deffnx procedure s64vector-append @var{s64vector}@dots{}
 @deffnx procedure subs64vector @var{s64vector} @var{start} @var{end}
+@deffnx procedure subs64vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subs64vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure u64vector? @var{obj}
@@ -5202,9 +5253,12 @@
 @deffnx procedure u64vector->list @var{u64vector}
 @deffnx procedure list->u64vector @var{list-of-exact-int64}
 @deffnx procedure u64vector-fill! @var{u64vector} @var{fill}
+@deffnx procedure append-u64vectors @var{lst}
 @deffnx procedure u64vector-copy @var{u64vector}
 @deffnx procedure u64vector-append @var{u64vector}@dots{}
 @deffnx procedure subu64vector @var{u64vector} @var{start} @var{end}
+@deffnx procedure subu64vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subu64vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure f32vector? @var{obj}
@@ -5216,9 +5270,12 @@
 @deffnx procedure f32vector->list @var{f32vector}
 @deffnx procedure list->f32vector @var{list-of-inexact-real}
 @deffnx procedure f32vector-fill! @var{f32vector} @var{fill}
+@deffnx procedure append-f32vectors @var{lst}
 @deffnx procedure f32vector-copy @var{f32vector}
 @deffnx procedure f32vector-append @var{f32vector}@dots{}
 @deffnx procedure subf32vector @var{f32vector} @var{start} @var{end}
+@deffnx procedure subf32vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subf32vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 @deffn procedure f64vector? @var{obj}
@@ -5230,9 +5287,12 @@
 @deffnx procedure f64vector->list @var{f64vector}
 @deffnx procedure list->f64vector @var{list-of-inexact-real}
 @deffnx procedure f64vector-fill! @var{f64vector} @var{fill}
+@deffnx procedure append-f64vectors @var{lst}
 @deffnx procedure f64vector-copy @var{f64vector}
 @deffnx procedure f64vector-append @var{f64vector}@dots{}
 @deffnx procedure subf64vector @var{f64vector} @var{start} @var{end}
+@deffnx procedure subf64vector-fill! @var{vector} @var{start} @var{end} @var{fill}
+@deffnx procedure subf64vector-move! @var{src-vector} @var{src-start} @var{src-end} @var{dst-vector} @var{dst-start}
 @end deffn
 
 For example: